namespace PkmnLib.Plugin.Gen7.Scripts.Abilities;

/// <summary>
/// Arena Trap is an ability that prevents opposing grounded Pokémon from fleeing or switching out of battle.
/// This effect does not apply to Flying-type Pokémon, those with Levitate, or those holding a Shed Shell.
///
/// <see href="https://bulbapedia.bulbagarden.net/wiki/Arena_Trap_(Ability)">Bulbapedia - Arena Trap</see>
/// </summary>
[Script(ScriptCategory.Ability, "arena_trap")]
public class ArenaTrap : Script, IScriptPreventOpponentRunAway, IScriptPreventOpponentSwitch
{
    private IPokemon? _owner;

    /// <inheritdoc />
    public override void OnAddedToParent(IScriptSource source)
    {
        if (source is not IPokemon pokemon)
            throw new InvalidOperationException("ArenaTrap can only be added to a Pokemon.");
        _owner = pokemon;
    }

    /// <inheritdoc />
    public void PreventOpponentRunAway(IFleeChoice choice, ref bool prevent)
    {
        if (choice.User.IsFloating)
            return;
        if (_owner is not null)
            choice.User.BattleData?.Battle.EventHook.Invoke(new AbilityTriggerEvent(_owner));
        prevent = true;
    }

    /// <inheritdoc />
    public void PreventOpponentSwitch(ISwitchChoice choice, ref bool prevent)
    {
        if (choice.User.IsFloating)
            return;
        if (_owner is not null)
            choice.User.BattleData?.Battle.EventHook.Invoke(new AbilityTriggerEvent(_owner));
        prevent = true;
    }
}